/**
 * http://foswiki.org/Extensions/SocialSharePlugin
 *
 * Copyright (c) 2015-2024 Michael Daum http://michaeldaumconsulting.com
 * Licensed under the GPL licenses
 */
"use strict";
(function($) {

  $(document).on("click", ".socialShareButton", function() {
    var url = foswiki.getScriptUrl("rest", "RenderPlugin", "template");

    $.ajax({
      url: url, 
      data: {
        "name": "socialshare",
        "expand": "dialog",
        "render": "on",
        "topic": foswiki.getPreference("WEB") + "." + foswiki.getPreference("TOPIC")
      },
      success: function(content) { 
        var $content = $(content);
        $.blockUI({
          message: $content,
          focusInput: false,
          blockMsgClass: "socialShareDialog",
          onBlock: function() {
            $(".blockOverlay").on("click", function() {
              $.unblockUI(); 
              return false;
            });
            $content.find("a").on("click", function() {
              $.unblockUI();
            });
          }
        });
      },
      error: function(xhr) {
        throw("ERROR: can't load dialog xhr=",xhr);
      }
    }); 

    return false;
  });

  $(document).on("click", ".socialShare .mastodon", function() {
    var $this = $(this),
        opts = $this.data(),
        url;

    if (!opts.domain) {
      opts.domain = localStorage.mastodonDomain;
    }

    if (!opts.domain) {
      opts.domain = prompt("Enter your Mastodon domain", "mastodon.social");
    }

    if (!opts.domain) {
      return;
    }

    localStorage.mastodonDomain = opts.domain;

    url = "https://" + opts.domain + "/share?text=" + opts.text;
    window.open(url, '_blank');
  });
})(jQuery);
